<ngx-loading [show]="isLoadingUpdate$ | async" />

<ng-container *subscribe="editDatasetMutation.result$ as dataset">
  <ngx-loading [show]="dataset.isLoading" />
</ng-container>

<div [ngClass]="[jds.card, jds.mb(20)]">
  <div [ngClass]="[jds.cardBody, jds.p(24)]">
    <ng-container *ngIf="isLoadingRead$ | async">
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: '90%',
            'border-radius': '0',
            height: '28px',
            'margin-bottom': '10px'
          }"
        />
      </div>
      <div
        class="wrapper-skeleton"
        *ngFor="let line of [40, 30]"
      >
        <ngx-skeleton-loader
          [theme]="{
            width: line + '%',
            'border-radius': '0',
            height: '20px',
            'margin-bottom': '10px'
          }"
        />
      </div>
    </ng-container>

    <ng-container *ngIf="(isLoadingRead$ | async) === false">
      <ng-container *ngIf="data$ | async as row">
        <div [ngClass]="className.header">
          <h6 [ngClass]="className.title">{{ row.name }}</h6>
          <div
            [ngClass]="className.action"
            [style.flexShrink]="0"
          >
            <ng-container *ngIf="!accessCoreData">
              <button
                [ngClass]="[jds.button, jds.buttonPrimary, jds.d('flex')]"
                disabled
                type="button"
              >
                <span>Unduh Dataset</span>
                <jds-bi-icon
                  [ngClass]="[jds.ms(8)]"
                  name="chevron-down"
                />
              </button>
            </ng-container>

            <ng-container *ngIf="accessCoreData">
              <jds-bi-hosted-dropdown
                [(open)]="isDropdownDownload"
                [jdsBiDropdownLimitWidth]="'auto'"
                [content]="dropdownDownload"
              >
                <button
                  [ngClass]="[jds.button, jds.buttonPrimary, jds.d('flex')]"
                  type="button"
                >
                  <span>Unduh Dataset</span>
                  <jds-bi-icon
                    [ngClass]="[jds.ms(8)]"
                    name="chevron-down"
                  />
                </button>
              </jds-bi-hosted-dropdown>

              <ng-template #dropdownDownload>
                <ul
                  [ngClass]="[jds.dropdownMenu]"
                  [style.minWidth.px]="150"
                >
                  <ng-container *ngIf="row.dataset_type.id === 4">
                    <li [ngClass]="[jds.dropdownNavbarItem]">
                      <a
                        [ngClass]="[jds.dropdownNavbarLink]"
                        (click)="accessCoreData && onDownload('pdf')"
                      >
                        PDF
                      </a>
                    </li>
                  </ng-container>
                  <li [ngClass]="[jds.dropdownNavbarItem]">
                    <a
                      [ngClass]="[jds.dropdownNavbarLink]"
                      (click)="accessCoreData && onDownload('csv')"
                    >
                      CSV
                    </a>
                  </li>
                  <li [ngClass]="[jds.dropdownNavbarItem]">
                    <a
                      [ngClass]="[jds.dropdownNavbarLink]"
                      (click)="accessCoreData && onDownload('excel')"
                    >
                      Excel
                    </a>
                  </li>
                  <li [ngClass]="[jds.dropdownNavbarItem]">
                    <a
                      [ngClass]="[jds.dropdownNavbarLink]"
                      (click)="accessCoreData && onAccessAPI()"
                    >
                      API
                    </a>
                  </li>
                </ul>
              </ng-template>
            </ng-container>

            <!-- Dropdown Dataset Action -->
            @if (
              satudataUser.role_name === 'walidata' ||
              (satudataUser.role_name === 'opd' &&
                satudataUser.kode_skpd === row.skpd.kode_skpd)
            ) {
              @if (
                getAccessAction(
                  getStatusCatalog(row.is_validate, row.is_active)
                )
              ) {
                <jds-bi-hosted-dropdown
                  [(open)]="isDropdownAction"
                  [jdsBiDropdownLimitWidth]="'auto'"
                  [jdsBiDropdownAlign]="'right'"
                  [content]="dropdownAction"
                >
                  <button
                    [ngClass]="[
                      jds.button,
                      jds.buttonDefault,
                      jds.d('flex'),
                      jds.ms(10)
                    ]"
                    type="button"
                  >
                    <jds-bi-icon name="ellipsis" />
                  </button>
                </jds-bi-hosted-dropdown>

                <ng-template #dropdownAction>
                  <app-dropdown-dataset-action
                    [datasetID]="row.id"
                    [datasetLastCategory]="row.history_draft.category_before"
                    [status]="getStatusCatalog(row.is_validate, row.is_active)"
                    (delete)="onDelete($event)"
                    (archive)="onArchive($event)"
                    (active)="onActive($event)"
                    (active)="onActive($event)"
                    (recover)="onRecover($event)"
                    (discontinue)="onDiscontinue($event)"
                  />
                </ng-template>

                <app-modal-dataset-status
                  [status]="getStatusCatalog(row.is_validate, row.is_active)"
                  (update)="onUpdate($event)"
                />
              }
            }
          </div>
        </div>
        <div [ngClass]="[jds.d('flex'), jds.alignItems('start')]">
          <div [ngClass]="jds.me(48)">
            <div
              [ngClass]="[
                jds.fs(14),
                jds.mb(8),
                jds.text(jdsBiColor.gray['600'])
              ]"
              [style.lineHeight.px]="20"
            >
              Dimensi Dataset
            </div>
            <div
              [ngClass]="[jds.d('flex')]"
              [style.verticalAlign]="'middle'"
            >
              <jds-bi-icon
                [ngClass]="[jds.me(6), jds.text(jdsBiColor.gray['600'])]"
                name="calendar"
              />
              <span
                [ngClass]="[jds.fs(14)]"
                [style.position]="'relative'"
                [style.top.px]="1"
                [style.lineHeight.px]="23"
              >
                {{ getDimension(row.metadata) }}
              </span>
            </div>
          </div>

          <div [ngClass]="jds.me(48)">
            <div
              [ngClass]="[
                jds.fs(14),
                jds.mb(8),
                jds.text(jdsBiColor.gray['600'])
              ]"
              [style.lineHeight.px]="20"
            >
              Status
            </div>
            @if (data.is_discontinue === 3) {
              <span
                [colorScheme]="'red'"
                jdsBiBadge
                variant="subtle"
              >
                Diskontinu
              </span>
            } @else {
              <span
                [colorScheme]="
                  getSource(row.is_realtime, row.is_permanent).color
                "
                [ngClass]="[jds.rounded('pill')]"
                jdsBiBadge
                variant="subtle"
              >
                <jds-bi-icon
                  [name]="getSource(row.is_realtime, row.is_permanent).icon"
                  [ngClass]="[jds.me(4)]"
                />
                <span>
                  {{ getSource(row.is_realtime, row.is_permanent).name }}
                </span>
              </span>
            }
          </div>

          <div [ngClass]="jds.me(48)">
            <div
              [ngClass]="[
                jds.fs(14),
                jds.mb(8),
                jds.text(jdsBiColor.gray['600'])
              ]"
              [style.lineHeight.px]="20"
            >
              Klasifikasi
            </div>
            <span
              [colorScheme]="getClassificationColor(row.dataset_class.id)"
              jdsBiBadge
            >
              {{ row.dataset_class.name }}
            </span>
          </div>

          <div [ngClass]="jds.me(48)">
            <div
              [ngClass]="[
                jds.fs(14),
                jds.mb(8),
                jds.text(jdsBiColor.gray['600'])
              ]"
              [style.lineHeight.px]="20"
            >
              Topik
            </div>
            <div
              [ngClass]="[jds.d('flex')]"
              [style.verticalAlign]="'middle'"
            >
              <jds-bi-icon
                [ngClass]="[jds.me(6), jds.text(jdsBiColor.gray['600'])]"
                name="book"
              />
              <span
                [ngClass]="[jds.fs(14)]"
                [style.position]="'relative'"
                [style.top.px]="1"
                [style.lineHeight.px]="23"
              >
                {{ row.sektoral.name }}
              </span>
            </div>
          </div>

          <div
            *ngIf="row.category === 'Data Agregat'"
            [ngClass]="jds.me(48)"
          >
            <div
              [ngClass]="[
                jds.fs(14),
                jds.mb(8),
                jds.text(jdsBiColor.gray['600'])
              ]"
              [style.lineHeight.px]="20"
            >
              Kualitas Data
            </div>
            <span
              *ngIf="row.quality_score_point !== 0; else emptyScore"
              [ngClass]="[
                jds.alignItems('center'),
                jds.text(getQualityScoreColor(row.quality_score_point))
              ]"
              [style.borderColor]="
                getQualityScoreColor(row.quality_score_point)
              "
              jdsBiBadge
              variant="outline"
            >
              <svg
                [ngClass]="[jds.me(8)]"
                width="10"
                height="10"
                viewBox="0 0 10 10"
                xmlns="http://www.w3.org/2000/svg"
                fill="currentColor"
              >
                <rect
                  width="10"
                  height="10"
                  rx="2"
                />
              </svg>
              {{ row.quality_score_label }}
            </span>

            <ng-template #emptyScore>-----------</ng-template>
          </div>

          <div [ngClass]="jds.me(48)">
            <div
              [ngClass]="[
                jds.fs(14),
                jds.mb(8),
                jds.text(jdsBiColor.gray['600'])
              ]"
              [style.lineHeight.px]="20"
            >
              Dataset Diperbarui
            </div>
            <div
              [ngClass]="[jds.d('flex')]"
              [style.verticalAlign]="'middle'"
            >
              <jds-bi-icon
                [ngClass]="[jds.me(6), jds.text(jdsBiColor.gray['600'])]"
                name="clock-three"
              />
              <span
                [ngClass]="[jds.fs(14)]"
                [style.position]="'relative'"
                [style.top.px]="1"
                [style.lineHeight.px]="23"
              >
                {{ moment(row.mdate).locale('id').format('DD MMMM YYYY') }}
              </span>
            </div>
          </div>
        </div>
      </ng-container>
    </ng-container>
  </div>
</div>

<!-- Modal Download -->
<app-modal
  id="modal-download"
  #modal
  [isClose]="false"
  position="center"
>
  <ng-container ngProjectAs="body">
    <div [ngClass]="[jds.mt(10), jds.mb(10)]">
      <h6>Unduh Dataset {{ downloadName ? '"' + downloadName + '"' : '' }}</h6>
      <div [ngClass]="[jds.d('flex'), jds.mb(8)]">
        Proses pengaksesan dataset
        <span [ngClass]="jds.ms('auto')">{{ downloadProgress }}%</span>
      </div>
      <div [ngClass]="jds.progress">
        <div
          [ngClass]="[
            jds.progressBar,
            jds.progressBarStriped,
            jds.progressBarAnimated,
            jds.bg('success')
          ]"
          [style.width.%]="downloadProgress"
          role="progressbar"
          aria-label="Unduh Dataset"
        ></div>
      </div>
    </div>
  </ng-container>
</app-modal>
